#
# jdwang@asia.edu.tw 
# 2009.3.16
# 2009.4.14

use strict;
use LWP::UserAgent;

#perl Get104BankJobPages.pl 1
die "Usage: perl Get104BankJobPages.pl <TimeInterval>\n" unless @ARGV == 1;
my $TimeInterval = $ARGV[0];

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year = $year+1900; #(year from 1900)
$mon = $mon + 1; #(m=0..11)
my $DownLoadDate = $year."_".$mon."_".$mday;

#print "$sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst\n";
#print "$DownLoadDate\n";exit;

#my $URL = "http://www.104.com.tw/jobbank/bank/index.cfm?cat=3&no=1001000000"; # for get;
#my $action = "/jobbank/joblist/joblist.cfm?jobsource=104_bank&hotjob_chr=0";

my $URL = "http://www.104.com.tw/jobbank/joblist/joblist.cfm?jobsource=104_bank&hotjob_chr=0"; # nκ~

my $Parameters = [
"sel_role"=>"1",
"sel_main_jobcat"=>"0",
"sel_sub_jobcat"=>"0",
"sel_loc"=>"0",
#"sel_indcat" value="1001000000",#1001001000
"sel_indcat"=>"1001001000",
"position_id"=>"104_bank",
"cat"      	=>"3",
"no"      	=>"1001000000",
"s_name"    =>"qlTM"
];

my ($content, $status, $is_Success, $resp) = jdwang_post($URL,$Parameters);

#print ($content);exit;
sleep $TimeInterval;

my $NumOfPages = jdwang_NumPages($content);
my $NumJobPerPage = 30;
my $TotalPages = int($NumOfPages/$NumJobPerPage)+1;
#print ($NumOfPages);
#print ($content);exit;

my $OutputDir = "../JobsPages/";
if (-d $OutputDir) {
	
} else {
	mkdir $OutputDir;
}
my $OutputDir1 = "../JobsPages/$DownLoadDate/";
if (-d $OutputDir1) {
	
} else {
	mkdir $OutputDir1;
}

for (my $x=1;$x<=$TotalPages;$x++) {
#for (my $x=1;$x<=3;$x++) {
	print "Getting $x page.... \n";
	my $Parameters2 = [
	"sel_sub_jobcat"=>"0",
	"sel_roledesc"=>"¾u@",
	"sel_main_jobcatdesc"=>"п¾",
	"sel_sub_jobcatdesc"=>"¾ȲӶ",
	"sel_indcatdesc"=>"",
	"sel_locdesc"=>"пܦa",
	"sel_handicapdesc"=>"ݻ٧O",
	"page"=>"$x",
	"sortfield"=>"appear_date",
	"sortmode"=>"desc",
	"sortlog"=>"appear_date|desc",
	"searchvalue_log"=>"1|0|0|1001001000|0|0",
	"kwslog"=>"",
	"search_type"=>"",
	"position_num"=>"2",
	"position_id"=>"",
	"position_log"=>"104_bank",
	"query_total_page"=>"4307",
	'cat'=>'3',
	's_name'=>'qlTM',
	'no'=>'1001000000',
	"set_flag"=>"",
	"return_url"=>"http://pda.104.com.tw/my104/mate/mate_save.cfm",
	"add_channel_url"=>"http://pda.104.com.tw/my104/mate/mate_save.cfm",
	"new_member_url"=>"http://pda.104.com.tw/my104/mate/mate_save.cfm",
	"xxx"=>"",
	"sel_role"=>"1",
	"sel_main_jobcat_name"=>"",
	"sel_main_jobcat_name1"=>"",
	"sel_main_jobcat_name2"=>"",
	"sel_main_jobcat"=>"0",
	"sel_main_jobcat1"=>"0",
	"sel_main_jobcat2"=>"0",              
	"sel_indcat_name"=>"nκ~",
	"sel_indcat_name2"=>"",
	"sel_indcat_name3"=>"",
	"sel_indcat"=>"1001001000",
	"sel_indcat2"=>"0",
	"sel_indcat3"=>"0",
	"sel_loc_name"=>"",
	"sel_loc_name2"=>"",
	"sel_loc_name3"=>"",
	"sel_loc"=>"0",
	"sel_loc2"=>"",
	"sel_loc3"=>""
	];
	my $URL2 = "http://www.104.com.tw/jobbank/joblist/joblist.cfm?jobsource=104_bank&hotjob_chr=0";
	
	my ($content2, $status2, $is_Success2, $resp2) = jdwang_post($URL2,$Parameters2);
	
	my $OutputFileLocation = $OutputDir1.$DownLoadDate."_$x"."Page.txt";
	
	open(output,">$OutputFileLocation") or die "can't open $OutputFileLocation";
	
	print output $content2;
	
	close(output);
	#print ($content2);
	sleep ($TimeInterval);

} # end of for (my $x=1;$x<=$TotalPages;$x++) {

#################################
use LWP;
my $browser;
sub jdwang_post {
	my ($URL,$Parameters) = @_;
	my $browser = LWP::UserAgent->new() unless $browser;
	my $response = $browser->post($URL,$Parameters);
	#print ($response->content);
	return($response->content,$response->status_line,$response->is_success, $response) if wantarray;	
	return unless $response->is_success ;
	return $response->content;
} # end of sub jdwang_post {
#################################
sub jdwang_get {
	
	my ($URL) = @_;
	
	my $browser = LWP::UserAgent->new unless $browser;
	
	my $response = $browser->get($URL);
	
	return($response->content,$response->status_line,$response->is_success, $response) if wantarray;
	
	return unless $response->is_success ;
	
	return $response->content;
} # end of sub jdwang_get {
###############################
#
#X`@X
#
sub jdwang_NumPages{
	my ($Content) = @_;
	#print "$Content";exit;
	my ($NumOfPages) = $Content =~ /\<span class=\"number13\"\>(.+)\<\/span\>/;	
	#print ($NumOfPages);
	return($NumOfPages);
} # end of sub jdwang_NumPages{

