#
# 2009.4.11
# 2009.4.12 => lwp	
# jdwang@asia.edu.tw
#


use strict;
#use LWP::Simple;
use LWP::Simple;

#perl GetEachJobPage.pl  ../JobsList/2009_4_14JobIDList.txt 2
die "Usage: perl GetEachJobPage.pl ../JobsList/2009_4_14JobIDList.txt <TimeInterval>\n" unless @ARGV == 2;
my $TimeInterval = $ARGV[0];
#my $TimeInterval = 1;

my $JobsSrcDir = "../JobsSrcFile/";
mkdir $JobsSrcDir;
#perl GetEachJobPage.pl  ../JobsList/2009_4_11JobIDList.txt
my $InputFilename = $ARGV[0];
my ($Date) = $InputFilename =~ /\.\.\/JobsList\/.+\/(.+)JobIDList\.txt/;

open (input,"<$InputFilename");
my $cnt = 0;
while (my $Line = <input>) {
	$cnt++;
	chomp($Line);
	my ($JobDate,$URL) = split / /,$Line;
	
	my $JobID = "";
	
	if ($URL =~ /^http\:\/\/www\.104\.com\.tw/) {
		#www.104.com.tw
		($JobID) = $URL =~/j=(.+)\&jobsource=104_bank/;
	} elsif ($URL =~ /^http\:\/\/www\.104temp\.com\.tw/) {
		#www.104temp.com.tw 
		($JobID) = $URL =~/\&jobno=(.+)\&invoice/;
	} else {
		print "\nparse jobID error!\n";exit;
	}
	#jobno=4455774
	
	my $OutputFileLocation = $JobsSrcDir."$JobDate"."_$JobID".".html";
	
	if (-e $OutputFileLocation) {
		# the Job have been downloaded.
		print "It existed=>$OutputFileLocation\n";
	} else {
		#my $Src = get($URL);
		#print "$cnt=>$JobDate $JobID\n";
		#open (output,">$OutputFileLocation");
		#print output $Src;
		#close(output); 
		getstore($URL,$OutputFileLocation);	
	}
	sleep($TimeInterval);
} # end of while (my $URL = <input>) {



