#
# 2009.4.12
#
# jdwang@asia.edu.tw
#
#use utf8;
use strict;
use Data::Dumper;
use lib "../Program/jdwang_lib";
use jdwangPackage;

my $SrcLocationDir = $ARGV[0];
#perl ParseJobsID.pl ../JobsSrcFile/

my $OutputDir = "../JobsConditions/";
mkdir $OutputDir;
my $OutputFile = "JobMainCondition.txt";
my $OutputFilename = $OutputDir.$OutputFile;
open (output,">$OutputFilename") or die "can't open $OutputFilename";

#
# Extract the seq files names from the Dir specified by the user 
#
my @SegFileAry = ();
my $SeqFilesCnt = jdwangPackage::DirFilenames($SrcLocationDir,\@SegFileAry);
#print Dumper(@SegFileAry);exit;
my $TotalJobCnt = 0;
my $ConditionCnt = 0;
my %Conditions = ();
for (my $i=0;$i<$#SegFileAry+1;$i++)
#for (my $i=0;$i<1;$i++)
{
	my $InputFileLocation = $SrcLocationDir.$SegFileAry[$i]; 
	print "Extracting $SegFileAry[$i]\n";
	open (input,"$InputFileLocation") or die "can't open $InputFileLocation";
	$TotalJobCnt++;
	while (my $Line = <input>) {	
		next if ($Line !~ /\xE3\x80\x90(.+)\xE3\x80\x91/);
	  	#print "===>$1\n";
	  	my $OneCondition = $1;
	  	
	  	if (exists $Conditions{$OneCondition}){
	  		
  		} else {
	  		$ConditionCnt++;
  		}	
  		$Conditions{$OneCondition}++;
	} # ene of while (my $Line = <input>) {	
	close(input);
} # end of  for (my $i=0;$i<$#SegFileAry+1;$i++)

#print Dumper(%Conditions);
#
# output Job Main Condition file
#
print output "#ConditionTypeCnt=$ConditionCnt\n";
print output "#Total=$TotalJobCnt\n";
foreach my $key (keys %Conditions) {
	#print "$key\n";
	my $Ratio = $Conditions{$key}/$TotalJobCnt;
	print output "$key $Conditions{$key} ".(sprintf "%1.3f",$Ratio)."\n";
}
close(output);

