#
# 2009.4.12
#
# jdwang@asia.edu.tw
#
#use utf8;
use strict;
use Data::Dumper;
use lib "../Program/jdwang_lib";
use jdwangPackage;

my $SrcLocationDir = $ARGV[0];
#perl ParseJobsID.pl ../JobsSrcFile/

my $OutputDir = "../JobsConditions/";
mkdir $OutputDir;
my $OutputFile = "JobConditions.txt";
my $OutputFilename = $OutputDir.$OutputFile;
open (output,">$OutputFilename") or die "can't open $OutputFilename";

#
# Extract the seq files names from the Dir specified by the user 
#
my @SegFileAry = ();
my $SeqFilesCnt = jdwangPackage::DirFilenames($SrcLocationDir,\@SegFileAry);
#print Dumper(@SegFileAry);exit;
my $TotalJobCnt = 0;
my $ConditionCnt = 0;
my %SkillConditions = ();
for (my $i=0;$i<$#SegFileAry+1;$i++)
#for (my $i=0;$i<1;$i++)
{
	my $InputFileLocation = $SrcLocationDir.$SegFileAry[$i]; 
	print "Extracting $SegFileAry[$i]\n";
	open (input,"$InputFileLocation") or die "can't open $InputFileLocation";
	$TotalJobCnt++;
	while (my $Line = <input>) {	
		if ($Line =~ /\xE3\x80\x90(.+)\xE3\x80\x91/){#ij
		  	if ($Line =~ /\xE6\x93\x85\xE9\x95\xb7\xE5\xb7\xa5\xE5\x85\xb7/){#ժu
			  	$Line = <input>; # read in the next line
			  	 
			  	while ($Line =~ /<td><span class="learnlink">(.+)<\/span>\xEF\xBC\x9A(.+)/g) {;
					my $SkillType = $1;
					my $SkillLine = $2;
					#print "$SkillType\n";
					#print "$SkillLine\n";exit;
				  	my @Items = split /\xe3\x80\x81/,$SkillLine;# G=>\xe3\x80\x81
				  	for (my $i=0;$i<= $#Items;$i++) { 
					  my ($OneSkill) = 	$Items[$i] =~ /color=\"#0000ff\">(.+)<\/font><\/a>/;
					  $SkillConditions{$OneSkill}++;	
				  	}
	  			} # end of whiel (Line =~ /<td><span class="learnlink">(.+)</span>G(.+)/g) {;
	  		} # end of if ($Line =~ /\xE6\x93\x85\xE9\x95\xb7\xE5\xb7\xa5\xE5\x85\xb7/){
		} # end of if ($Line =~ /\xE3\x80\x90(.+)\xE3\x80\x91/){
	} # ene of while (my $Line = <input>) {	
	close(input);
} # end of  for (my $i=0;$i<$#SegFileAry+1;$i++)

#print Dumper(%SkillConditions);
#
# output Job Main Condition file
#
#print output "#ConditionTypeCnt=$ConditionCnt\n";
print output "#Total=$TotalJobCnt\n";
foreach my $key (keys %SkillConditions) {
	print "$key\n";
	my $Ratio = $SkillConditions{$key}/$TotalJobCnt;
	print output "$key#".(sprintf "%1.3f",$Ratio)."#$SkillConditions{$key}\n";
}
close(output);


