#
# 2009.4.11
# 2009.4.14
# jdwang@asia.edu.tw
#
use strict;
use Data::Dumper;
use lib "../Program/jdwang_lib";
use jdwangPackage;

my $SrcLocationDir = $ARGV[0];
#perl ParseJobsID.pl ../JobsPages/2009_4_14/
my ($Date) = $SrcLocationDir =~ /\.\.\/JobsPages\/(.+)\//;
#print "$Date";exit;

my $URL = "http://www.104.com.tw";
my $OutputDir = "../JobsList/";
if (-d $OutputDir) {
} else {
	mkdir $OutputDir;
}
my $FileName = $Date."JobIDList.txt";
my $OutputFilename = $OutputDir.$FileName;
open (output,">$OutputFilename") or die "can't open $OutputFilename";

#my $SrcLocationDir = "../JobsPages/";

#
# Extract the seq files names from the Dir specified by the user 
#
my @SegFileAry = ();
my $SeqFilesCnt = jdwangPackage::DirFilenames($SrcLocationDir,\@SegFileAry);

#print Dumper(@SegFileAry);exit;

for (my $i=0;$i<$#SegFileAry+1;$i++)
{
	my $InputFileLocation = $SrcLocationDir.$SegFileAry[$i]; 
	print "Extracting $InputFileLocation\n";
	my ($Filename,$mark, $ext) = $SegFileAry[$i] =~  /^(.+)(\.)?(.+)?/g;
	
	open (input1,"$InputFileLocation") or die "can't open $InputFileLocation";
	my $line = "";
	my $cnt = 0;
	my $JobDate = "";
	while ($line = <input1>) {
		my @items = ();
		my $JobID = "";
	    if (($line =~ m/<tr  onMouseOver/)||($line =~ m/<tr bgcolor="#FFF9D7" onMouseOver/)){
		    for (my $i=1;$i<=7;$i++) {
			    $items[$i] = <input1>;
		    }
		    $cnt++;
		    #<td class="number10_1">04/11</td>
			($JobDate) = $items[2] =~ /\<td class=\"number10_1\"\>(.+)\<\/td\>/;
			# 04/11 => 04_11
			$JobDate =~ s/\//_/;
		    
		    ($JobID) = $items[3] =~ /a href=\"(.+)\" target="/;
		    #print "$cnt =>$JobID\n"; 
		    if ($JobID =~ /^http/) {
			    #<td><a href="http://www.104temp.com.tw/job/job_intro.jsp?jobsource=104_bank&jobno=4455774&invoice=89888888000&leads=10&page=2&hotjob_chr=0" target=
		    	print output "$JobDate $JobID\n";
	    	} else {
		    	##<td><a href="/jobbank/cust_job/job.cfm?j=55754770493b445b36373f6841433d653554f497245614326262626223e402b2a735j53&jobsource=104_bank&page=1&hotjob_chr=0" target="joblist_job" title="<oN--{}ou{v(T)ԲӸ>">oN--{...</a></td>
		    	print output "$JobDate $URL$JobID\n";
	    	}
	    }   # end of   if ($line =~ m/<tr  onMouseOver/){
	} # end of while ($line = <input1>) {
	close(input);
} # end of  for (my $i=0;$i<$#SegFileAry+1;$i++)
close(output);